## chromono 1.1.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

project(chromono)

add_definitions(-Wall -Werror)

set(CMAKE_CXX_STANDARD 11)

include_directories("${chromono_SOURCE_DIR}/src")
include_directories("${chromono_SOURCE_DIR}/src/renderer")
include_directories("${chromono_SOURCE_DIR}/src/circle1d")
include_directories(${CMAKE_CURRENT_BINARY_DIR})

find_package(PkgConfig REQUIRED)

pkg_check_modules(ZLIB REQUIRED zlib)
list(APPEND LIBRARIES ${ZLIB_LIBRARIES})
include_directories(${ZLIB_INCLUDE_DIRS})
link_directories(${ZLIB_LIBRARY_DIRS})

pkg_check_modules(VORBIS REQUIRED vorbisfile)
list(APPEND LIBRARIES ${VORBIS_LIBRARIES})
include_directories(${VORBIS_INCLUDE_DIRS})
link_directories(${VORBIS_LIBRARY_DIRS})

pkg_check_modules(SDL2 REQUIRED sdl2)
list(APPEND LIBRARIES ${SDL2_LIBRARIES})
include_directories(${SDL2_INCLUDE_DIRS})
link_directories(${SDL2_LIBRARY_DIRS})

set(OpenGL_GL_PREFERENCE GLVND)
find_package(OpenGL REQUIRED)
list(APPEND LIBRARIES ${OPENGL_LIBRARIES})
include_directories(${OPENGL_INCLUDE_DIRS})

file(GLOB CORE_SOURCES "${chromono_SOURCE_DIR}/src/*.cpp")
file(GLOB RENDERER_SOURCES "${chromono_SOURCE_DIR}/src/renderer/*.cpp")
file(GLOB CIRCLE1D_SOURCES "${chromono_SOURCE_DIR}/src/circle1d/*.cpp")

set(RESOURCE_DIRS
    data/images
    data/markup
    data/shaders
    data/sounds
)

set(RESOURCES "")
foreach(RESOURCE_DIR ${RESOURCE_DIRS})
    file(GLOB RESOURCES_PART "${chromono_SOURCE_DIR}/${RESOURCE_DIR}/*")
    list(APPEND RESOURCES "${RESOURCES_PART}")
endforeach()

set(RE_SOURCES "resources.cpp")
set(RESOURCE_PACKER "${chromono_SOURCE_DIR}/packer.py")

add_custom_command(
    OUTPUT ${RE_SOURCES} resources.h
    COMMAND python3 ${RESOURCE_PACKER} ${RESOURCES} ${RE_SOURCES}
    DEPENDS ${RESOURCES} ${RESOURCE_PACKER}
)

add_executable(chromono
    ${CORE_SOURCES} ${RENDERER_SOURCES} ${CIRCLE1D_SOURCES} ${RE_SOURCES})

target_link_libraries(chromono ${LIBRARIES})

install(TARGETS chromono)
install(FILES ${chromono_SOURCE_DIR}/chromono.desktop DESTINATION share/applications)
install(FILES ${chromono_SOURCE_DIR}/chromono.png DESTINATION share/pixmaps)

=== debian/changelog ===
chromono (1.1.1-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix build with GCC-15. (Closes: #1114081)
  * Switch from pkg-config to pkgconf.

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 14 Sep 2025 19:40:57 +0200

chromono (1.1.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No-change rebuild to allow testing migration after NEW acceptance.

 -- Chris Hofstaedtler <zeha@debian.org>  Sat, 06 Nov 2021 13:05:29 +0000

chromono (1.1.1-1) unstable; urgency=medium

  * Initial release (Closes: #992342)

 -- Thomas Perl <m@thp.io>  Tue, 17 Aug 2021 16:31:03 +0200

=== debian/control ===
Source: chromono
Section: games
Priority: optional
Maintainer: Thomas Perl <m@thp.io>
Build-Depends: debhelper-compat (= 13), cmake (>= 3.13), pkgconf,
 python3 (>= 3.3), libsdl2-dev, libgl-dev, zlib1g-dev, libvorbis-dev
Standards-Version: 4.5.1
Homepage: https://thp.io/2013/chromono/

Package: chromono
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Circular color puzzle game
 chro.mono is a puzzle game originally developed in 2013 for mobile devices.
 The goal of the game is to touch half-colored spheres with full-colored
 spheres in such a way that all spheres are filledwith a single color each.
 Later on in the game, additional limitations and variations on the game
 mechanics plus time limits keep the gameplay interesting.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:
	dh_auto_install
	mv -v debian/chromono/usr/bin debian/chromono/usr/games

## chromono 1.1.3

=== CMakeLists.txt ===
# 3.27 required for the GLES2 component of OpenGL
cmake_minimum_required(VERSION 3.27)

project(chromono)

option(USE_OPENGL_ES "Use OpenGL ES 2.0 instead of OpenGL 3.2" OFF)
option(BUILD_FOR_WII "Build for Wii using devkitPro and OpenGX" OFF)

add_definitions(-Wall -Werror -Wno-unused-variable)

set(CMAKE_CXX_STANDARD 17)

include_directories("${chromono_SOURCE_DIR}/src")
include_directories("${chromono_SOURCE_DIR}/src/renderer")
include_directories("${chromono_SOURCE_DIR}/src/circle1d")
include_directories(${CMAKE_CURRENT_BINARY_DIR})

if (DEFINED CROSSDEPS_SYSROOT)
  message(STATUS "Configuring for sysroot in ${CROSSDEPS_SYSROOT}")

  include_directories(${CROSSDEPS_SYSROOT}/include)
  link_directories(${CROSSDEPS_SYSROOT}/lib)

  include_directories(${CROSSDEPS_SYSROOT}/include/SDL2)

  if (WIN32)
      # For static linking
      list(APPEND LIBRARIES user32 gdi32 winmm imm32 ole32 oleaut32 shell32 setupapi version uuid)
      list(PREPEND LIBRARIES mingw32 glew32s)
      add_definitions(-DGLEW_STATIC)

      list(APPEND LIBRARIES opengl32)
  elseif (APPLE)
      # macOS
      list(APPEND LIBRARIES
          iconv
          objc
          -Wl,-framework,CoreAudio
          -Wl,-framework,AudioToolbox
          -Wl,-weak_framework,CoreHaptics
          -Wl,-weak_framework,GameController
          -Wl,-framework,ForceFeedback
          -lobjc
          -Wl,-framework,CoreVideo
          -Wl,-framework,Cocoa
          -Wl,-framework,Carbon
          -Wl,-framework,IOKit
          -Wl,-weak_framework,QuartzCore
          -Wl,-weak_framework,Metal
      )

      list(APPEND LIBRARIES -Wl,-framework,OpenGL)
  else()
      # Linux
      list(APPEND LIBRARIES dl pthread m util)

      list(APPEND LIBRARIES GL)
  endif()
  list(APPEND LIBRARIES SDL2main)
  list(PREPEND LIBRARIES SDL2 vorbisfile vorbis ogg z)
elseif (BUILD_FOR_WII)
  include_directories(
      /opt/devkitpro/portlibs/ppc/include
      /opt/devkitpro/portlibs/wii/include
      /opt/devkitpro/portlibs/wii/include/SDL2
      /opt/devkitpro/libogc/include
  )

  list(APPEND LIBRARIES
    /opt/devkitpro/portlibs/wii/lib/libopengx.a
    /opt/devkitpro/portlibs/wii/lib/libSDL2.a
    /opt/devkitpro/portlibs/wii/lib/libSDL2main.a

    /opt/devkitpro/libogc/lib/wii/libwiiuse.a
    /opt/devkitpro/libogc/lib/wii/libbte.a
    /opt/devkitpro/libogc/lib/wii/libwiikeyboard.a

    /opt/devkitpro/libogc/lib/wii/libfat.a
    /opt/devkitpro/libogc/lib/wii/libaesnd.a
    /opt/devkitpro/libogc/lib/wii/libasnd.a
    /opt/devkitpro/libogc/lib/wii/libogc.a

    /opt/devkitpro/portlibs/ppc/lib/libvorbisidec.a
    /opt/devkitpro/portlibs/ppc/lib/libvorbisfile.a
    /opt/devkitpro/portlibs/ppc/lib/libogg.a

    /opt/devkitpro/portlibs/ppc/lib/libz.a
  )
else()
  find_package(PkgConfig REQUIRED)

  pkg_check_modules(ZLIB REQUIRED zlib)
  list(APPEND LIBRARIES ${ZLIB_LIBRARIES})
  include_directories(${ZLIB_INCLUDE_DIRS})
  link_directories(${ZLIB_LIBRARY_DIRS})

  pkg_check_modules(VORBIS REQUIRED vorbisfile)
  list(APPEND LIBRARIES ${VORBIS_LIBRARIES})
  include_directories(${VORBIS_INCLUDE_DIRS})
  link_directories(${VORBIS_LIBRARY_DIRS})

  pkg_check_modules(SDL2 REQUIRED sdl2)
  list(APPEND LIBRARIES ${SDL2_LIBRARIES})
  include_directories(${SDL2_INCLUDE_DIRS})
  link_directories(${SDL2_LIBRARY_DIRS})

  set(OpenGL_GL_PREFERENCE GLVND)
  if (USE_OPENGL_ES)
    find_package(OpenGL REQUIRED COMPONENTS GLES2)
    list(APPEND LIBRARIES OpenGL::GLES2)
    add_definitions(-DUSE_OPENGL_ES)
  else()
    find_package(OpenGL REQUIRED COMPONENTS OpenGL)
    list(APPEND LIBRARIES OpenGL::OpenGL)
  endif()

  include_directories(${OPENGL_INCLUDE_DIRS})
endif()

file(GLOB CORE_SOURCES "${chromono_SOURCE_DIR}/src/*.cpp")
file(GLOB RENDERER_SOURCES "${chromono_SOURCE_DIR}/src/renderer/*.cpp")
file(GLOB CIRCLE1D_SOURCES "${chromono_SOURCE_DIR}/src/circle1d/*.cpp")

set(RESOURCE_DIRS
    data/images
    data/markup
    data/shaders
    data/sounds
)

set(RESOURCES "")
foreach(RESOURCE_DIR ${RESOURCE_DIRS})
    file(GLOB RESOURCES_PART "${chromono_SOURCE_DIR}/${RESOURCE_DIR}/*")
    list(APPEND RESOURCES "${RESOURCES_PART}")
endforeach()

set(RE_SOURCES "resources.cpp")
set(RESOURCE_PACKER "${chromono_SOURCE_DIR}/packer.py")

add_custom_command(
    OUTPUT ${RE_SOURCES} resources.h
    COMMAND python3 ${RESOURCE_PACKER} ${RESOURCES} ${RE_SOURCES}
    DEPENDS ${RESOURCES} ${RESOURCE_PACKER}
)

set(EXTRA_SOURCES "")
if (BUILD_FOR_WII)
  include_directories("${chromono_SOURCE_DIR}/src/wii")
  file(GLOB EXTRA_SOURCES "${chromono_SOURCE_DIR}/src/wii/*.cpp")
  add_definitions(-DBUILD_FOR_WII)
endif()

add_executable(chromono
    ${CORE_SOURCES} ${RENDERER_SOURCES} ${CIRCLE1D_SOURCES} ${RE_SOURCES} ${EXTRA_SOURCES})

target_link_libraries(chromono ${LIBRARIES})

install(TARGETS chromono)
install(FILES ${chromono_SOURCE_DIR}/chromono.desktop DESTINATION share/applications)
install(FILES ${chromono_SOURCE_DIR}/chromono.png DESTINATION share/pixmaps)

=== debian/changelog ===
chromono (1.1.3-1) unstable; urgency=medium

  * New upstream release, per info from Thomas.
    GCC-15 build fix is included in this release.
  * Add myself to Uploaders.
  * Remove version constraints satisfied since at least buster.
  * Add Build-Depends: libopengl-dev for cmake's OpenGL::OpenGL.

 -- Chris Hofstaedtler <zeha@debian.org>  Sat, 03 Jan 2026 16:28:54 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,9 @@
 Section: games
 Priority: optional
 Maintainer: Thomas Perl <m@thp.io>
-Build-Depends: debhelper-compat (= 13), cmake (>= 3.13), pkgconf,
- python3 (>= 3.3), libsdl2-dev, libgl-dev, zlib1g-dev, libvorbis-dev
+Uploaders: Chris Hofstaedtler <zeha@debian.org>
+Build-Depends: debhelper-compat (= 13), cmake, pkgconf,
+ python3, libsdl2-dev, libopengl-dev, libgl-dev, zlib1g-dev, libvorbis-dev
 Standards-Version: 4.5.1
 Homepage: https://thp.io/2013/chromono/
